/** SGX

The   sss    gggg x   x   
     s      g      x x    Engine
      sss   g  gg   x
         s  g   g  x x          Copyright 1995-2009.
     ssss    gggg x   x         Steven Goodwin. All Rights Reserved.
    
This version has been released under the GNU Public License v2.0.

Please see the license files for details.

File: sgx/include/sgx/filesystem/memorycard/memcarddevice.hpp

*/

#ifndef SGX_FILESYSTEM_MEMORYCARD_MEMORYCARD_DEVICE_HPP
#define SGX_FILESYSTEM_MEMORYCARD_MEMORYCARD_DEVICE_HPP


class CSGXDeviceMemoryCard : public CSGXDevice    // controlling manager
{
public:
    tMEM_SIZE m_Size;

    CSGXDeviceMemoryCard(const tUINT32 maxSize=4096);
    virtual ~CSGXDeviceMemoryCard() {}
    virtual tBOOL mountDirectory(CSGXFileEntry *pEntry, const sgxString &rootmount, tBOOL recursive);

    virtual CSGXDeviceBlockState *open(CSGXDeviceBlock *pBlk, const sgxString &access);

	virtual void getRoot(sgxString &rootPath);
	//
	
	CSGXFileEntry *addNewFile(CSGXFileEntry *pNewEntry);
	CSGXFileEntry *createNewFile(CSGXFileEntry *pParentEntry, const sgxString &filename);

	virtual tMEM_SIZE getBlockSize();

};


#endif // SGX_FILESYSTEM_MEMORYCARD_MEMORYCARD_DEVICE_HPP
